﻿Imports Telerik.WinControls
Imports Telerik.WinControls.UI
Imports Telerik.WinControls.Layouts
Imports System.Text

Partial Public Class Form1
Inherits Form
    Public Sub New()
        InitializeComponent()
       

        Me.radListView1.AllowEdit = False
        Me.RadListView1.AllowRemove = False
        Me.RadListView1.DisplayMember = "Make"
        Me.RadListView1.Dock = DockStyle.Fill
   
        SetupSimpleListView()
    End Sub
    Private Sub radListView1_VisualItemFormatting(sender As Object, e As Telerik.WinControls.UI.ListViewVisualItemEventArgs) Handles RadListView1.VisualItemFormatting

        If TypeOf e.VisualItem Is BaseListViewGroupVisualItem Then
            Return
        End If

        If Me.RadListView1.ViewType = ListViewType.IconsView Then
            e.VisualItem.Text = "" & "" & e.VisualItem.Data("Make").ToString() & "" & e.VisualItem.Data("Model").ToString() & "" & "" & e.VisualItem.Data("CarYear").ToString() & ", " & e.VisualItem.Data("CategoryName").ToString() & "" & "" & GetFeatures(e.VisualItem.Data).ToCharArray() & ""
            e.VisualItem.ImageLayout = ImageLayout.Center
            e.VisualItem.ImageAlignment = ContentAlignment.MiddleCenter
        End If

        If Me.RadListView1.ViewType = ListViewType.ListView Then
            e.VisualItem.Padding = New Padding(5, 5, 0, 5)
            e.VisualItem.Layout.LeftPart.Margin = New Padding(0, 0, 5, 0)
        End If
    End Sub
    Private Sub SetupSimpleListView()
        Me.radListView1.AllowArbitraryItemHeight = True

    End Sub
    Private Sub radListView1_VisualItemCreating(sender As Object, e As Telerik.WinControls.UI.ListViewVisualItemCreatingEventArgs) Handles RadListView1.VisualItemCreating

        If Me.RadListView1.ViewType = ListViewType.ListView AndAlso Not (TypeOf e.VisualItem Is BaseListViewGroupVisualItem) Then
            e.VisualItem = New CarsListVisualItem()
        End If
    End Sub
    Private Sub radListView1_ItemDataBound(sender As Object, e As Telerik.WinControls.UI.ListViewItemEventArgs) Handles RadListView1.ItemDataBound
        Dim img As Image = Image.FromFile(Application.StartupPath & "\Resources\CarRentalImages\" & e.Item("ImageFileName").ToString())
        e.Item.Image = img

    End Sub

    Private features As New List(Of String)() From { _
        "AirConditioner", _
        "Mp3Player", _
        "DVDPlayer", _
        "ABS", _
        "ESR", _
        "Navigation" _
    }

    Private Function ContainsFeature(item As ListViewDataItem, feature As String) As Boolean
        Return item(feature) IsNot Nothing AndAlso Convert.ToInt32(item(feature)) <> 0
    End Function

    Private Function GetFeatures(item As ListViewDataItem) As String
        Dim featuresString As New StringBuilder()

        For Each feature As String In Me.features
            If ContainsFeature(item, feature) Then
                featuresString.Append(feature & Convert.ToString(", "))
            End If
        Next

        If featuresString.Length > 1 Then
            featuresString.Remove(featuresString.Length - 2, 2)
        End If

        Return featuresString.ToString()
    End Function

    Private Sub Form1_Load_1(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'SofiaCarRentalDataSet.Cars' table. You can move, or remove it, as needed.
        Me.CarsTableAdapter.Fill(Me.SofiaCarRentalDataSet.Cars)

    End Sub
End Class

Public Class CarsListVisualItem
Inherits SimpleListViewVisualItem
    Private element1 As LightVisualElement
    Private element2 As LightVisualElement
    Private element3 As LightVisualElement
    Private element4 As LightVisualElement
    Private layout As StackLayoutPanel

    Protected Overrides Sub CreateChildElements()
        MyBase.CreateChildElements()

        Me.layout = New StackLayoutPanel()
        Me.layout.EqualChildrenWidth = True
        Me.layout.Margin = New Padding(180, 30, 0, 0)

        Me.element1 = New LightVisualElement()
        element1.TextAlignment = ContentAlignment.MiddleLeft
        element1.MinSize = New Size(170, 0)
        element1.NotifyParentOnMouseInput = True
        element1.ShouldHandleMouseInput = False
        Me.layout.Children.Add(Me.element1)

        Me.element2 = New LightVisualElement()
        element2.TextAlignment = ContentAlignment.MiddleLeft
        element2.MinSize = New Size(170, 0)
        element2.NotifyParentOnMouseInput = True
        element2.ShouldHandleMouseInput = False
        Me.layout.Children.Add(Me.element2)

        Me.element3 = New LightVisualElement()
        element3.TextAlignment = ContentAlignment.MiddleLeft
        element3.MinSize = New Size(170, 0)
        element3.NotifyParentOnMouseInput = True
        element3.ShouldHandleMouseInput = False
        Me.layout.Children.Add(Me.element3)

        Me.element4 = New LightVisualElement()
        element4.TextAlignment = ContentAlignment.MiddleLeft
        element4.MinSize = New Size(170, 0)
        element4.NotifyParentOnMouseInput = True
        element4.ShouldHandleMouseInput = False
        Me.layout.Children.Add(Me.element4)

        Me.Children.Add(Me.layout)
    End Sub

    Private Function ContainsFeature(item As ListViewDataItem, feature As String) As Boolean
        Return item(feature) IsNot Nothing AndAlso Convert.ToInt32(item(feature)) <> 0
    End Function

    Protected Overrides Sub SynchronizeProperties()
        MyBase.SynchronizeProperties()

        Me.Text = "<html><span style=""color:#141718;font-size:14.5pt;"">" & Me.Data("Make").ToString() & " " & Me.Data("Model").ToString() & "</span>"

        Me.element1.Text = "<html><span style=""color:#010102;font-size:10.5pt;font-family:Segoe UI Semibold;"">" & "Manufactured:<span style=""color:#13224D;font-family:Segoe UI;"">" & Me.Data("CarYear").ToString() & "</span>" & "<br>Category:<span style=""color:#13224D;font-family:Segoe UI;"">" & Me.Data("CategoryName").ToString() & "</span></span>"

        Me.element2.Text = "<html><span style=""color:#010102;font-size:10.5pt;font-family:Segoe UI Semibold;"">" & "ABS:" & (If(Me.ContainsFeature(Me.Data, "ABS"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "<br>ESR:" & (If(Me.ContainsFeature(Me.Data, "ESR"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "</span>"

        Me.element3.Text = "<html><span style=""color:#010102;font-size:10.5pt;font-family:Segoe UI Semibold;"">" & "MP3 Player:" & (If(Me.ContainsFeature(Me.Data, "Mp3Player"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "<br>DVD Player:" & (If(Me.ContainsFeature(Me.Data, "DVDPlayer"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "</span>"

        Me.element4.Text = "<html><span style=""color:#010102;font-size:10.5pt;font-family:Segoe UI Semibold;"">" & "Air Conditioner:" & (If(Me.ContainsFeature(Me.Data, "AirConditioner"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "<br>Navigation:" & (If(Me.ContainsFeature(Me.Data, "Navigation"), "<span style=""color:#13224D;font-family:Segoe UI;"">YES", "<span style=""color:#D71B0E;"">NO")) & "</span>" & "</span>"

        Me.TextAlignment = ContentAlignment.TopLeft
    End Sub

    Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
        Get
            Return GetType(SimpleListViewVisualItem)
        End Get
    End Property
End Class
